标签:hdu 线段树
题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1394
Problem Description
The inversion number of a given number sequence a1, a2, ..., an is the number of pairs (ai, aj) that satisfy i < j and ai > aj.
For a given sequence of numbers a1, a2, ..., an, if we move the first m >= 0 numbers to the end of the seqence, we will obtain another sequence. There are totally n such sequences as the following:
a1, a2, ..., an-1, an (where m = 0 - the initial seqence)
a2, a3, ..., an, a1 (where m = 1)
a3, a4, ..., an, a1, a2 (where m = 2)
...
an, a1, a2, ..., an-1 (where m = n-1)
You are asked to write a program to find the minimum inversion number out of the above sequences.
Input
The input consists of a number of test cases. Each case consists of two lines: the first line contains a positive integer n (n <= 5000); the next line contains a permutation of the n integers from 0 to n-1.
Output
For each case, output the minimum inversion number on a single line.
Sample Input
Sample Output
Author
CHEN, Gaoli
Source
转
题意:
在一个排列中,如果一对数的前后位置与大小顺序相反,即前面的数大于后面的数,那么它们就称为一个逆序。一个排列中逆序的总数就称为这个排列的逆序数。逆序数为偶数的排列称为偶排列;逆序数为奇数的排列称为奇排列。如2431中,21,43,41,31是逆序,逆序数是4,为偶排列。
也是就说,对于n个不同的元素,先规定各元素之间有一个标准次序(例如n个 不同的自然数,可规定从小到大为标准次序),于是在这n个元素的任一排列中,当某两个元素的先后次序与标准次序不同时,就说有1个逆序。一个排列中所有逆序总数叫做这个排列的逆序数。
题目的意思就好比给出一个序列
如:0 3 4 1 2
设逆序数初始n = 0;
由于0后面没有比它小的,n = 0
3后面有1,2 n = 2
4后面有1,2,n = 2+2 = 4;
所以该序列逆序数为 4
其根据题意移动产生的序列有
3 4 1 2 0 逆序数:8
4 1 2 0 3 逆序数:6
1 2 0 3 4 逆序数:2
2 0 3 4 1 逆序数:4
所以最小逆序数为2
PS:
逆序数的概念:在一个排列中,如果一对数的前后位置与大小顺序相反,即前面的数大于后面的数,那么它们就称为一个逆序。一个排列中逆序的总数就称为这个排列的逆序数。逆序数为偶数的排列称为偶排列;逆序数为奇数的排列称为奇排列。如2431中,21,43,41,31是逆序,逆序数是4,为偶排列。
逆序数计算方法是:在逐个元素读取原始数列时,每次读取都要查询当前已读取元素中大于当前元素的个数,加到sum里,最后得到的sum即为原始数列的逆序数。
接下来找数列平移后得到的最小逆序数,假设当前序列逆序数是sum,那么将a[0]移到尾部后逆序数的改变是之前比a[0]大的数全部与尾部a[0]组合成逆序数,假设数量为x,则x=n-1-a[0],而之前比a[0]小的数(也就是之前能和a[0]组合为逆序数的元素)不再与a[0]组合成逆序数,假设数量为y,则y=n-x-1,这样,新序列的逆序数就是sum+x-y=sum-2*a[0]+n-1;
接下来说明下线段树的作用,线段区间表示当前已读取的元素个数,比如[m,n]表示在数字m到n之间有多少个数已经读入,build时所有树节点全部为0就是因为尚未读数,update函数是将新读入的数字更新到线段树里,点更新,query函数是查询当前数字区间已存在的数字个数。
代码如下:
#include <cstdio>
#include <algorithm>
using namespace std;
#define lson l , mid , rt << 1
#define rson mid + 1 , r , rt << 1 | 1
#define maxn 5017
int tree[maxn << 2];
int a[maxn];
void PushUP(int rt)
{
tree[rt] = tree[rt << 1] + tree[rt << 1 | 1];
}
void build(int l, int r, int rt)
{
tree[rt] = 0;
if(l == r)
{
return;
}
int mid = (l + r) >> 1;
build(lson);
build(rson);
}
void update(int p, int l, int r, int rt)
{
if(l == r)
{
tree[rt] = 1;//表示这个位置的数出现
return;
}
int mid = (l + r) >> 1;
if(p <= mid)//递归更新左子树或者右子树
update(p, lson);
else
update(p, rson);
PushUP(rt);
}
int query(int L, int R, int l, int r, int rt)
{
if(L <= l && r <= R)
{
return tree[rt];
}
int mid = (l + r) >> 1;
int ret = 0;
if (L <= mid)
ret += query(L , R , lson);
if (mid < R)
ret += query(L , R , rson);
return ret;
}
int main()
{
int n;
while(~scanf("%d", &n))
{
build(0, n-1, 1);
int sum = 0; //最开始的数列的逆序数
for(int i = 0; i < n; i++)
{
scanf("%d",&a[i]);
//查询当前线段树中比a[i]大的数有多少个
int tt = query(a[i], n-1, 0, n - 1, 1);
sum+=tt;
//把a[i]插入线段树中
update(a[i], 0, n-1, 1);
}
int minn = sum;
for(int i = 0; i < n; ++i)
{
sum = sum - 2 * a[i] + n - 1;
if(sum < minn)
{
minn = sum;
}
}
printf("%d\n",minn);
}
return 0;
}
版权声明:本文为博主原创文章,未经博主允许不得转载。
HDU 1394 Minimum Inversion Number(线段树求逆序数啊)
标签:hdu 线段树
原文地址:http://blog.csdn.net/u012860063/article/details/48139339